Index: squid/src/neighbors.c
diff -u squid/src/neighbors.c:1.1.1.2 squid/src/neighbors.c:1.1.1.2.10.1
--- squid/src/neighbors.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/neighbors.c	Fri Nov 10 10:44:52 2000
@@ -381,7 +381,7 @@
     mem->ping_reply_callback = callback;
     mem->ircb_data = callback_data;
     *timeout = 0.0;
-    reqnum = icpSetCacheKey(entry->key);
+    reqnum = icpSetCacheKey(entry->Skey);
     for (i = 0, p = first_ping; i++ < Config.npeers; p = p->next) {
 	if (p == NULL)
 	    p = Config.peers;
@@ -393,7 +393,7 @@
 	    p->host, url);
 	if (p->type == PEER_MULTICAST)
 	    mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
-	debug(15, 3) ("neighborsUdpPing: key = '%s'\n", storeKeyText(entry->key));
+	debug(15, 3) ("neighborsUdpPing: key = '%s'\n", storeKeyText(entry->Skey));
 	debug(15, 3) ("neighborsUdpPing: reqnum = %d\n", reqnum);
 
 #if USE_HTCP
@@ -551,7 +551,8 @@
 #endif
     return LOOKUP_NONE;
 }
-
+    if (!request->flags.hierarchical)
+	return NULL;
 /* select best peer based on cache digests */
 peer *
 neighborsDigestSelect(request_t * request, StoreEntry * entry)
@@ -578,8 +579,10 @@
 	if (lookup == LOOKUP_NONE)
 	    continue;
 	choice_count++;
-	if (lookup == LOOKUP_MISS)
+	if (lookup == LOOKUP_MISS) {
+	    cacheDigestGuessStatsUpdate(&p->digest->stats.guess, 0, 0);
 	    continue;
+	}
 	p_rtt = netdbHostRtt(p->host);
 	debug(15, 5) ("neighborsDigestSelect: peer %s rtt: %d\n",
 	    p->host, p_rtt);
@@ -760,7 +763,7 @@
 	return;
     }
     /* check if someone is already fetching it */
-    if (EBIT_TEST(entry->flags, ENTRY_DISPATCHED)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_DISPATCHED)) {
 	debug(15, 3) ("neighborsUdpAck: '%s' already being fetched.\n",
 	    storeKeyText(key));
 	neighborCountIgnored(p);
@@ -1067,7 +1070,7 @@
     mem->ircb_data = psstate;
     mcastSetTtl(theOutIcpConnection, p->mcast.ttl);
     p->mcast.id = mem->id;
-    reqnum = icpSetCacheKey(fake->key);
+    reqnum = icpSetCacheKey(fake->Skey);
     query = icpCreateMessage(ICP_QUERY, 0, url, reqnum, 0);
     icpUdpSend(theOutIcpConnection,
 	&p->in_addr,
@@ -1100,7 +1103,7 @@
 	p->mcast.avg_n_members,
 	p->stats.rtt);
     p->mcast.n_replies_expected = (int) p->mcast.avg_n_members;
-    EBIT_SET(fake->flags, ENTRY_ABORTED);
+    EBIT_SET(fake->Sflag, ENTRY_ABORTED);
     requestUnlink(fake->mem_obj->request);
     fake->mem_obj->request = NULL;
     storeReleaseRequest(fake);
Index: squid/src/net_db.c
diff -u squid/src/net_db.c:1.1.1.2 squid/src/net_db.c:1.1.1.2.10.1
--- squid/src/net_db.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/net_db.c	Fri Nov 10 10:44:52 2000
@@ -587,7 +587,7 @@
     debug(38, 3) ("netdbExchangeHandleReply: used %d entries, (x %d bytes) == %d bytes total\n",
 	nused, rec_sz, nused * rec_sz);
     debug(38, 3) ("netdbExchangeHandleReply: seen %d, used %d\n", ex->seen, ex->used);
-    if (EBIT_TEST(ex->e->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(ex->e->Sflag, ENTRY_ABORTED)) {
 	debug(38, 3) ("netdbExchangeHandleReply: ENTRY_ABORTED\n");
 	netdbExchangeDone(ex);
     } else if (ex->e->store_status == STORE_PENDING) {
Index: squid/src/pconn.c
diff -u squid/src/pconn.c:1.1.1.2 squid/src/pconn.c:1.1.1.2.28.1
--- squid/src/pconn.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/pconn.c	Fri Nov 10 10:44:52 2000
@@ -205,7 +205,7 @@
     p->fds[p->nfds++] = fd;
     commSetSelect(fd, COMM_SELECT_READ, pconnRead, p, 0);
     commSetTimeout(fd, Config.Timeout.pconn, pconnTimeout, p);
-    snprintf(desc, FD_DESC_SZ, "%s idle connection", host);
+    snprintf(desc, FD_DESC_SZ, "http://%s/ idle connection", host);
     fd_note(fd, desc);
     debug(48, 3) ("pconnPush: pushed FD %d for %s\n", fd, key);
 }
Index: squid/src/peer_digest.c
diff -u squid/src/peer_digest.c:1.1.1.2 squid/src/peer_digest.c:1.1.1.2.10.1
--- squid/src/peer_digest.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/peer_digest.c	Fri Nov 10 10:44:52 2000
@@ -179,8 +179,8 @@
 peerDigestNewDelay(const StoreEntry * e)
 {
     assert(e);
-    if (e->expires > 0)
-	return e->expires + PeerDigestReqMinGap - squid_curtime;
+    if (e->Sexpires > 0)
+	return e->Sexpires + PeerDigestReqMinGap - squid_curtime;
     return PeerDigestReqMinGap;
 }
 
@@ -309,11 +309,11 @@
 	storeClientListAdd(old_e, fetch);
     }
     e = fetch->entry = storeCreateEntry(url, url, req->flags, req->method);
-    assert(EBIT_TEST(e->flags, KEY_PRIVATE));
+    assert(EBIT_TEST(e->Sflag, KEY_PRIVATE));
     storeClientListAdd(e, fetch);
     /* set lastmod to trigger IMS request if possible */
     if (old_e)
-	e->lastmod = old_e->lastmod;
+	e->Slastmod = old_e->Slastmod;
 
     /* push towards peer cache */
     debug(72, 3) ("peerDigestRequest: forwarding to fwdStart...\n");
@@ -540,7 +540,7 @@
 	    reason = "swap failure";
 	else if (!fetch->entry)
 	    reason = "swap aborted?!";
-	else if (EBIT_TEST(fetch->entry->flags, ENTRY_ABORTED))
+	else if (EBIT_TEST(fetch->entry->Sflag, ENTRY_ABORTED))
 	    reason = "swap aborted";
     }
     /* continue checking (maybe-successful eof case) */
@@ -715,14 +715,14 @@
     fetch->recv.bytes = fetch->entry->store_status == STORE_PENDING ?
 	mem->inmem_hi : mem->object_sz;
     fetch->sent.msg = fetch->recv.msg = 1;
-    fetch->expires = fetch->entry->expires;
+    fetch->expires = fetch->entry->Sexpires;
     fetch->resp_time = squid_curtime - fetch->start_time;
 
     debug(72, 3) ("peerDigestFetchFinish: recv %d bytes in %d secs\n",
 	fetch->recv.bytes, fetch->resp_time);
     debug(72, 3) ("peerDigestFetchFinish: expires: %d (%+d), lmt: %d (%+d)\n",
 	fetch->expires, fetch->expires - squid_curtime,
-	fetch->entry->lastmod, fetch->entry->lastmod - squid_curtime);
+	fetch->entry->Slastmod, fetch->entry->Slastmod - squid_curtime);
 }
 
 
Index: squid/src/peer_select.c
diff -u squid/src/peer_select.c:1.1.1.2 squid/src/peer_select.c:1.1.1.2.10.1
--- squid/src/peer_select.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/peer_select.c	Fri Nov 10 10:44:52 2000
@@ -117,7 +117,7 @@
     debug(44, 3) ("peerSelectIcpPing: %s\n", storeUrl(entry));
     if (!request->flags.hierarchical && direct != DIRECT_NO)
 	return 0;
-    if (EBIT_TEST(entry->flags, KEY_PRIVATE) && !neighbors_do_private_keys)
+    if (EBIT_TEST(entry->Sflag, KEY_PRIVATE) && !neighbors_do_private_keys)
 	if (direct != DIRECT_NO)
 	    return 0;
     n = neighborsCount(request);
@@ -609,3 +609,22 @@
 	FS = &(*FS)->next;
     *FS = fs;
 }
+
+void
+freeFwdServer(FwdServer *fs)
+{
+    if (fs->peer)
+	cbdataUnlock(fs->peer);
+    memFree(fs, MEM_FWD_SERVER);
+}
+
+void
+freeFwdServers(FwdServer ** FS)
+{
+    FwdServer *fs;
+    while ((fs = *FS)) {
+	*FS = fs->next;
+	freeFwdServer(fs);
+    }
+}
+
Index: squid/src/protos.h
diff -u squid/src/protos.h:1.1.1.2 squid/src/protos.h:1.1.1.2.10.1
--- squid/src/protos.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/protos.h	Fri Nov 10 10:44:52 2000
@@ -620,6 +620,8 @@
 #if USE_HTCP
 extern void neighborsHtcpReply(const cache_key *, htcpReplyData *, const struct sockaddr_in *);
 #endif
+extern void freeFwdServer(FwdServer *);
+extern void freeFwdServers(FwdServer **);
 
 extern void netdbInit(void);
 extern void netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt);
@@ -773,6 +775,7 @@
  */
 extern StoreEntry *new_StoreEntry(int, const char *, const char *);
 extern StoreEntry *storeGet(const cache_key *);
+extern void storeHashDelete(StoreEntry *);
 extern StoreEntry *storeGetPublic(const char *uri, const method_t method);
 extern StoreEntry *storeCreateEntry(const char *, const char *, request_flags, method_t);
 extern void storeSetPublicKey(StoreEntry *);
@@ -826,7 +829,7 @@
 extern void storeAppendVPrintf(StoreEntry *, const char *, va_list ap);
 extern int storeCheckCachable(StoreEntry * e);
 extern void storeUnlinkFileno(int fileno);
-extern void storeSetPrivateKey(StoreEntry *);
+extern void storeSetPrivateKey(StoreEntry *, unsigned);
 extern int objectLen(const StoreEntry * e);
 extern int contentLen(const StoreEntry * e);
 extern HttpReply *storeEntryReply(StoreEntry *);
@@ -873,6 +876,7 @@
 /*
  * store_dir.c
  */
+extern SwapDir*getswapdir(int);
 extern char *storeSwapFullPath(int, char *);
 extern char *storeSwapSubSubDir(int, char *);
 extern int storeVerifySwapDirs(void);
@@ -886,8 +890,8 @@
 extern void storeDirCloseTmpSwapLog(int dirn);
 extern void storeDirOpenSwapLogs(void);
 extern void storeDirCloseSwapLogs(void);
-extern char *storeDirSwapLogFile(int, const char *);
-extern void storeDirSwapLog(const StoreEntry *, int op);
+extern void storeDirSwapLog(StoreEntry *, int op);
+extern storeSwapLogData *storeSwapAppendList(SwapDir*, storeSwapLogData*);
 extern int storeDirNumber(int fileno);
 extern void storeDirUpdateSwapSize(int fn, size_t size, int sign);
 extern int storeDirProperFileno(int dirn, int fn);
Index: squid/src/redirect.c
diff -u squid/src/redirect.c:1.1.1.2 squid/src/redirect.c:1.1.1.2.10.1
--- squid/src/redirect.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/redirect.c	Fri Nov 10 10:44:52 2000
@@ -103,7 +103,9 @@
     cbdataAdd(r, cbdataXfree, 0);
     r->orig_url = xstrdup(http->uri);
     r->client_addr = conn->log_addr;
-    if (conn->ident == NULL || *conn->ident == '\0') {
+    if (ntohs(conn->me.sin_port) == Config.Port.bhttp) {
+	r->client_ident = "B";
+    } else if (conn->ident == NULL || *conn->ident == '\0') {
 	r->client_ident = dash_str;
     } else {
 	r->client_ident = conn->ident;
@@ -114,11 +116,11 @@
     cbdataLock(r->data);
     if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
 	fqdn = dash_str;
-    snprintf(buf, 8192, "%s %s/%s %s %s\n",
+    snprintf(buf, 8192, "%s %s %s/%s %s\n\n",
+	r->client_ident,
 	r->orig_url,
 	inet_ntoa(r->client_addr),
 	fqdn,
-	r->client_ident,
 	r->method_s);
     helperSubmit(redirectors, buf, redirectHandleReply, r);
 }
Index: squid/src/refresh.c
diff -u squid/src/refresh.c:1.1.1.2 squid/src/refresh.c:1.1.1.2.12.1
--- squid/src/refresh.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/refresh.c	Fri Nov 10 10:44:52 2000
@@ -133,7 +133,7 @@
 
     debug(22, 3) ("refreshCheck(%s): '%s'\n", rc->proto, uri ? uri : "<none>");
     rc->total++;
-    if (EBIT_TEST(entry->flags, ENTRY_REVALIDATE)) {
+    if (EBIT_TEST(entry->Sflag, ENTRY_REVALIDATE)) {
 	debug(22, 3) ("refreshCheck: YES: Required Authorization\n");
 	rc->revalidate_stale++;
 	return 1;
@@ -156,10 +156,10 @@
 #endif
     debug(22, 3) ("refreshCheck: Matched '%s %d %d%% %d'\n",
 	pattern, (int) min, (int) (100.0 * pct), (int) max);
-    age = check_time - entry->timestamp;
+    age = check_time - entry->Stimestamp;
     debug(22, 3) ("refreshCheck: age = %d\n", (int) age);
     debug(22, 3) ("\tcheck_time:\t%s\n", mkrfc1123(check_time));
-    debug(22, 3) ("\tentry->timestamp:\t%s\n", mkrfc1123(entry->timestamp));
+    debug(22, 3) ("\tentry->Stimestamp:\t%s\n", mkrfc1123(entry->Stimestamp));
     /* request-specific checks */
     if (request) {
 #if HTTP_VIOLATIONS
@@ -202,8 +202,8 @@
 	return 0;
     }
 #endif
-    if (entry->expires > -1) {
-	if (entry->expires <= check_time) {
+    if (entry->Sexpires > -1) {
+	if (entry->Sexpires <= check_time) {
 	    debug(22, 3) ("refreshCheck: YES: expires <= curtime\n");
 	    rc->response_expires_stale++;
 	    return 1;
@@ -225,8 +225,8 @@
 	return 0;
     }
 #endif
-    if (entry->lastmod > -1 && entry->timestamp > entry->lastmod) {
-	factor = (double) age / (double) (entry->timestamp - entry->lastmod);
+    if (entry->Slastmod > -1 && entry->Stimestamp > entry->Slastmod) {
+	factor = (double) age / (double) (entry->Stimestamp - entry->Slastmod);
 	debug(22, 3) ("refreshCheck: factor = %f\n", factor);
 	if (factor < pct) {
 	    debug(22, 3) ("refreshCheck: NO: factor < pct\n");
@@ -237,11 +237,11 @@
 	    rc->last_modified_factor_stale++;
 	    return 1;
 	}
-    } else if (entry->lastmod > -1 && entry->timestamp == entry->lastmod) {
+    } else if (entry->Slastmod > -1 && entry->Stimestamp == entry->Slastmod) {
 	debug(22, 3) ("refreshCheck: YES: last-modified 'now'\n");
 	rc->response_lmt_now_stale++;
 	return 1;
-    } else if (entry->lastmod > -1 && entry->timestamp < entry->lastmod) {
+    } else if (entry->Slastmod > -1 && entry->Stimestamp < entry->Slastmod) {
 	debug(22, 3) ("refreshCheck: MAYBE: last-modified in the future\n");
 	rc->response_lmt_future_maybe++;
     }
@@ -267,7 +267,7 @@
     if (!refreshCheck(entry, NULL, 60, &refreshCounts[rcStore]))
 	/* Does not need refresh. This is certainly cachable */
 	return 1;
-    if (entry->lastmod < 0)
+    if (entry->Slastmod < 0)
 	/* Last modified is needed to do a refresh */
 	return 0;
     if (entry->mem_obj == NULL)
Index: squid/src/snmp_agent.c
diff -u squid/src/snmp_agent.c:1.1.1.2 squid/src/snmp_agent.c:1.1.1.2.12.1
--- squid/src/snmp_agent.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/snmp_agent.c	Fri Nov 10 10:44:52 2000
@@ -312,7 +312,11 @@
 	break;
     case PERF_SYS_CURLRUEXP:
 	Answer->type = SMI_TIMETICKS;
+#if HPL_REPL
+	*(Answer->val.integer) = 0;
+#else
 	*(Answer->val.integer) = (snint) (storeExpiredReferenceAge() * 100);
+#endif
 	break;
     case PERF_SYS_CURUNLREQ:
 	*(Answer->val.integer) = (snint) Counter.unlink.requests;
Index: squid/src/squid.h
diff -u squid/src/squid.h:1.1.1.2 squid/src/squid.h:1.1.1.2.10.1
--- squid/src/squid.h:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/squid.h	Fri Nov 10 10:44:52 2000
@@ -82,6 +82,9 @@
 #if HAVE_STDLIB_H
 #include <stdlib.h>
 #endif
+#if HAVE_STDDEF_H
+#include <stddef.h>
+#endif
 #if HAVE_STDIO_H
 #include <stdio.h>
 #endif
Index: squid/src/stat.c
diff -u squid/src/stat.c:1.1.1.2 squid/src/stat.c:1.1.1.2.10.1
--- squid/src/stat.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/stat.c	Fri Nov 10 10:44:52 2000
@@ -201,7 +201,7 @@
 storeEntryFlags(const StoreEntry * entry)
 {
     LOCAL_ARRAY(char, buf, 256);
-    int flags = (int) entry->flags;
+    int flags = (int) entry->Sflag;
     char *t;
     buf[0] = '\0';
     if (EBIT_TEST(flags, ENTRY_SPECIAL))
@@ -240,10 +240,10 @@
 {
     LOCAL_ARRAY(char, buf, 256);
     snprintf(buf, 256, "LV:%-9d LU:%-9d LM:%-9d EX:%-9d",
-	(int) entry->timestamp,
-	(int) entry->lastref,
-	(int) entry->lastmod,
-	(int) entry->expires);
+	(int) entry->Stimestamp,
+	(int) entry->Slastref,
+	(int) entry->Slastmod,
+	(int) entry->Sexpires);
     return buf;
 }
 
@@ -253,7 +253,7 @@
     MemObject *mem = e->mem_obj;
     int i;
     struct _store_client *sc;
-    storeAppendPrintf(s, "KEY %s\n", storeKeyText(e->key));
+    storeAppendPrintf(s, "KEY %s\n", storeKeyText(e->Skey));
     if (mem)
 	storeAppendPrintf(s, "\t%s %s\n",
 	    RequestMethodStr[mem->method], mem->log_url);
@@ -263,9 +263,9 @@
     storeAppendPrintf(s, "\t%d locks, %d clients, %d refs\n",
 	(int) e->lock_count,
 	storePendingNClients(e),
-	(int) e->refcount);
+	(int) e->Srefcount);
     storeAppendPrintf(s, "\tSwap File %#08X\n",
-	e->swap_file_number);
+	e->Sswap_file_number);
     if (mem != NULL) {
 	storeAppendPrintf(s, "\tinmem_lo: %d\n", (int) mem->inmem_lo);
 	storeAppendPrintf(s, "\tinmem_hi: %d\n", (int) mem->inmem_hi);
@@ -311,7 +311,7 @@
 	storeUnlockObject(state->sentry);
 	cbdataFree(state);
 	return;
-    } else if (EBIT_TEST(state->sentry->flags, ENTRY_ABORTED)) {
+    } else if (EBIT_TEST(state->sentry->Sflag, ENTRY_ABORTED)) {
 	storeUnlockObject(state->sentry);
 	cbdataFree(state);
 	return;
@@ -489,8 +489,12 @@
 	store_swap_size);
     storeAppendPrintf(sentry, "\tStorage Mem size:\t%d KB\n",
 	(int) (store_mem_size >> 10));
+    #ifdef	HPL_REPL
+    /* The non-LRU policies do not use referenceAge */
+    #else	/* HPL_REPL */
     storeAppendPrintf(sentry, "\tStorage LRU Expiration Age:\t%6.2f days\n",
 	(double) storeExpiredReferenceAge() / 86400.0);
+    #endif	/* HPL_REPL */
     storeAppendPrintf(sentry, "\tMean Object Size:\t%0.2f KB\n",
 	n_disk_objects ? (double) store_swap_size / n_disk_objects : 0.0);
     storeAppendPrintf(sentry, "\tRequests given to unlinkd:\t%d\n",
@@ -603,6 +607,8 @@
 	memInUse(MEM_STOREENTRY));
     storeAppendPrintf(sentry, "\t%6d StoreEntries with MemObjects\n",
 	memInUse(MEM_MEMOBJECT));
+    storeAppendPrintf(sentry, "\t%6d storeSwapLogData temporaries\n",
+	memInUse(MEM_STORESWAPLOGDATA));
     storeAppendPrintf(sentry, "\t%6d Hot Object Cache Items\n",
 	hot_obj_count);
     storeAppendPrintf(sentry, "\t%6d Filemap bits set\n",
@@ -824,9 +830,11 @@
     cachemgrRegister("filedescriptors",
 	"Process Filedescriptor Allocation",
 	statFiledescriptors, 0, 1);
+#ifdef DEBUG_ALLOBJECTS
     cachemgrRegister("objects",
 	"All Cache Objects",
 	stat_objects_get, 0, 0);
+#endif
     cachemgrRegister("vm_objects",
 	"In-Memory and In-Transit Objects",
 	stat_vmobjects_get, 0, 0);
@@ -1336,9 +1344,9 @@
 	    http->out.offset, http->out.size);
 	storeAppendPrintf(s, "req_sz %d\n", http->req_sz);
 	e = http->entry;
-	storeAppendPrintf(s, "entry %p/%s\n", e, e ? storeKeyText(e->key) : "N/A");
+	storeAppendPrintf(s, "entry %p/%s\n", e, e ? storeKeyText(e->Skey) : "N/A");
 	e = http->old_entry;
-	storeAppendPrintf(s, "old_entry %p/%s\n", e, e ? storeKeyText(e->key) : "N/A");
+	storeAppendPrintf(s, "old_entry %p/%s\n", e, e ? storeKeyText(e->Skey) : "N/A");
 	storeAppendPrintf(s, "start %d.%06d (%f seconds ago)\n", http->start.tv_sec,
 	    http->start.tv_usec,
 	    tvSubDsec(http->start, current_time));
